/*
 *      Script par Valentin Bloch      
 *
 */

using UnityEngine;

public enum PlayerState
{
    walk,
    interact
}

public class PlayerMovement : MonoBehaviour
{
    public float speed;
    private Rigidbody2D myRigidbody;
    private Vector3 change;
    private Animator animator;
    public PlayerState currentState;
    public int stage = 0;
    public GameObject player;

    // Start is called before the first frame update
    void Start()
    {
        currentState = PlayerState.walk;

        animator = GetComponent<Animator>();
        myRigidbody = GetComponent<Rigidbody2D>();

        animator.SetFloat("moveX", 0);
        animator.SetFloat("moveY", -1);

    }

    // Update is called once per frame
    void Update()
    {

        change = Vector3.zero;
        change.x = Input.GetAxisRaw("Horizontal");
        change.y = Input.GetAxisRaw("Vertical");

        if(currentState == PlayerState.walk)
        {
            UpdateAnimationAndMove();
        }


        Vector3 pos = Camera.main.WorldToViewportPoint(transform.position);
        pos.x = Mathf.Clamp01(pos.x);
        pos.y = Mathf.Clamp01(pos.y);
        transform.position = Camera.main.ViewportToWorldPoint(pos);

        if (this.GetComponent<PlayerNature>().currentNature >= 100 && stage == 0)
        {
            GenerateMap.instance.generateBoutique(0, 1, "chaussure");
            stage++;
        }
        else if (stage == 1)
        {
            GenerateMap.instance.generateUsine(1, 1);
            stage++;
        }
        else if (this.GetComponent<PlayerNature>().currentNature >= 100 && stage == 2)
        {
            GenerateMap.instance.generateBoutique(0, 2, "baton");
            stage++;
        }
        else if (stage == 3)
        {
            GenerateMap.instance.generateUsine(1, 2);
            stage++;
        }
        else if (this.GetComponent<PlayerNature>().currentNature >= 100 && stage == 4)
        {
            GenerateMap.instance.generateBoutique(2, 0, "rechaud");
            stage++;
        }
        else if (stage == 5)
        {
            GenerateMap.instance.generateUsine(2, 1);
            stage++;
        }
        else if (this.GetComponent<PlayerNature>().currentNature >= 100 && stage == 6)
        {
            GenerateMap.instance.generateBoutique(0, 0, "tente");
            stage++;
        }
        else if (stage == 7)
        {
            GenerateMap.instance.generateUsine(1, 0);
            stage++;
        }
    }

    void MoveCharacter()
    {
        change.Normalize();
        myRigidbody.MovePosition(transform.position + change * speed * Time.deltaTime);
    }

    void UpdateAnimationAndMove()
    {
        if (change != Vector3.zero)
        {
            MoveCharacter();
            animator.SetFloat("moveX", change.x);
            animator.SetFloat("moveY", change.y);

            animator.SetBool("moving", true);
        }
        else
        {
            animator.SetBool("moving", false);
        }
    }
}
